# generated by datamodel-codegen:
#   filename:  redis_definitions.json

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import Optional, Union


class DisableSSL(Enum):
    """
    Disable SSL mode
    """

    disable = 'disable'


@dataclass
class DisableSSLMode:
    """
    Disable SSL mode.
    """

    mode: DisableSSL


class Enable(Enum):
    """
    Verify-full SSL mode. Always require encryption and verifies the identity of the server.
    """

    verify_full = 'verify-full'


@dataclass
class VerifyFullSSLMode:
    """
    Verify-full SSL mode. Always require encryption and verifies the identity of the server.
    """

    ca_cert: str
    client_cert: str
    client_key: str
    mode: Enable


@dataclass
class RedisConnectorResource:
    host: str
    password: Optional[str]
    port: int
    ssl_mode: Optional[Union[DisableSSLMode, VerifyFullSSLMode]]
    username: Optional[str]
    ssl: Optional[bool] = False
